
_G.GeneralMenuPanel = class(Turbine.UI.Control);

function GeneralMenuPanel:Constructor(window)
	Turbine.UI.Control.Constructor(self);
	
	self.window = window;
	self.width = 275;
	self.height = 105;
	
	self:SetBackColor(Turbine.UI.Color(0.925,0,0,0));
	
	self.listBox = Turbine.UI.ListBox();
	self.listBox:SetParent(self);
	self.listBox:SetPosition(10,10);
	
	self.content = Turbine.UI.Control();
	self.content:SetParent(self.listBox);
	self.content:SetBackColor(Turbine.UI.Color(0.925,0,0,0));
	
	self.autoSelect = Turbine.UI.Lotro.CheckBox(autoSelectNewEncounters);
	self.autoSelect:SetTop(4);
	self.autoSelect:SetMultiline(false);
	self.autoSelect:SetCheckAlignment(Turbine.UI.ContentAlignment.MiddleRight);
	self.autoSelect:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleRight);
	self.autoSelect:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.autoSelect:SetForeColor(control2LightColor);
	self.autoSelect:SetText(L.AutoSelectNewEncounters .. " ");
	self.autoSelect:SetParent(self.content);
	self.autoSelect:SetSize(self.width-50,30);
	self.autoSelect.MouseDown = function(sender,args)
		WindowManager.MouseWasPressed(self.window);
	end
	self.autoSelect.MouseDoubleClick = function(sender,args)
		self.autoSelect:SetChecked(not self.autoSelect:IsChecked());
	end
	
	self.autoSelect.CheckedChanged = function(sender,args)
		if (autoSelectNewEncounters ~= self.autoSelect:IsChecked()) then
			Misc.SetValue("autoSelectNewEncounters",self.autoSelect:IsChecked());
			_G.settings.autoSelectNewEncounters = _G.autoSelectNewEncounters;
			SaveSettings();
		end
	end
	Misc.AddListener("autoSelectNewEncounters", function(sender)
		if (sender.autoSelect:IsChecked() ~= autoSelectNewEncounters) then
			sender.autoSelect:SetChecked(autoSelectNewEncounters);
		end
	end, self);
	
	self.confirmOnReset = Turbine.UI.Lotro.CheckBox(confirmOnReset);
	self.confirmOnReset:SetTop(36);
	self.confirmOnReset:SetMultiline(false);
	self.confirmOnReset:SetCheckAlignment(Turbine.UI.ContentAlignment.MiddleRight);
	self.confirmOnReset:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleRight);
	self.confirmOnReset:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.confirmOnReset:SetForeColor(control2LightColor);
	self.confirmOnReset:SetText(L.ConfirmDialogOnReset .. " ");
	self.confirmOnReset:SetParent(self.content);
	self.confirmOnReset:SetSize(self.width-50,30);
	self.confirmOnReset.MouseDown = function(sender,args)
		WindowManager.MouseWasPressed(self.window);
	end
	
	self.confirmOnReset.CheckedChanged = function(sender,args)
		if (confirmOnReset ~= self.confirmOnReset:IsChecked()) then
			Misc.SetValue("confirmOnReset",self.confirmOnReset:IsChecked());
			_G.settings.confirmOnReset = _G.confirmOnReset;
			SaveSettings();
		end
	end
	Misc.AddListener("confirmOnReset", function(sender)
		if (sender.confirmOnReset:IsChecked() ~= confirmOnReset) then
			sender.confirmOnReset:SetChecked(confirmOnReset);
		end
	end, self);
	
	self.saveButton = Turbine.UI.Lotro.Button();
	self.saveButton:SetTop(79);
	self.saveButton:SetText(L.SaveData);
	self.saveButton:SetParent(self.content);
	self.saveButton:SetSize(120,30);
	self.saveButton.MouseDown = function(sender,args)
		WindowManager.MouseWasPressed(self.window);
	end
	
	self.saveButton.Click = function(sender,args)
		fileSelectDialog:Show(true);
	end
	
	self.loadButton = Turbine.UI.Lotro.Button();
	self.loadButton:SetTop(79);
	self.loadButton:SetText(L.LoadData);
	self.loadButton:SetParent(self.content);
	self.loadButton:SetSize(120,30);
	self.loadButton.MouseDown = function(sender,args)
		WindowManager.MouseWasPressed(self.window);
	end
	
	self.loadButton.Click = function(sender,args)
		fileSelectDialog:Show(false);
	end
	
	self.listBox:AddItem(self.content);
	
	self.vScroll = Turbine.UI.Lotro.ScrollBar();
	self.vScroll:SetParent(self);
	self.vScroll:SetBackColor(Turbine.UI.Color(0.925,0,0,0));
	self.vScroll:SetOrientation(Turbine.UI.Orientation.Vertical);
	self.vScroll:SetWidth(10);
	self.listBox:SetVerticalScrollBar(self.vScroll);
	
	self.hScroll = Turbine.UI.Lotro.ScrollBar();
	self.hScroll:SetParent(self);
	self.hScroll:SetBackColor(Turbine.UI.Color(0.925,0,0,0));
	self.hScroll:SetOrientation(Turbine.UI.Orientation.Horizontal);
	self.hScroll:SetHeight(10);
	self.listBox:SetHorizontalScrollBar(self.hScroll);
end

function GeneralMenuPanel:Layout()
	local w,h = self:GetSize();
	
	self.listBox:SetSize(w-20,h-20);
	self.content:SetSize(math.max(self.width,w-20),math.max(self.height,h-20));
	
	self.autoSelect:SetLeft(math.max(0,(w-20-self.width)/2)+25);
	self.confirmOnReset:SetLeft(math.max(0,(w-20-self.width)/2)+25);
	
	self.saveButton:SetLeft(math.max(0,(w-20-self.width)/2)+5);
	self.loadButton:SetLeft(math.max(0,(w-20-self.width)/2)+self.width-125);
	
	self.vScroll:SetLeft(w-10);
	self.vScroll:SetHeight(h-18);
	self.hScroll:SetTop(h-10);
	self.hScroll:SetWidth(w);
end

function GeneralMenuPanel:MouseDown()
	if (self.window ~= nil) then WindowManager.MouseWasPressed(self.window) end
end